"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getS3BucketStorageClassFromStorageDriveTier = exports.matchUrl = exports.randomGuid = void 0;
const crypto_1 = require("crypto");
const node_match_path_1 = require("node-match-path");
const quidproquo_core_1 = require("quidproquo-core");
const randomGuid = () => {
    return (0, crypto_1.randomUUID)();
};
exports.randomGuid = randomGuid;
const matchUrl = (path, url) => {
    console.log('Matching: ', path);
    // /attempt/{attemptUuid}/result/{test} => /attempt/:attemptUuid/result/:test
    const modifiedPath = path.replaceAll(/{(.+?)}/g, (m, g) => `:${g}`);
    const matchResult = (0, node_match_path_1.match)(modifiedPath, url);
    return {
        didMatch: matchResult.matches,
        params: matchResult.params,
    };
};
exports.matchUrl = matchUrl;
const getS3BucketStorageClassFromStorageDriveTier = (driveTier) => {
    switch (driveTier) {
        case quidproquo_core_1.StorageDriveTier.REGULAR:
            return 'STANDARD';
        case quidproquo_core_1.StorageDriveTier.OCCASIONAL_ACCESS:
            return 'STANDARD_IA';
        case quidproquo_core_1.StorageDriveTier.SINGLE_ZONE_OCCASIONAL_ACCESS:
            return 'ONEZONE_IA';
        case quidproquo_core_1.StorageDriveTier.COLD_STORAGE:
            return 'GLACIER';
        case quidproquo_core_1.StorageDriveTier.COLD_STORAGE_INSTANT_ACCESS:
            return 'GLACIER_IR';
        case quidproquo_core_1.StorageDriveTier.DEEP_COLD_STORAGE:
            return 'DEEP_ARCHIVE';
        case quidproquo_core_1.StorageDriveTier.SMART_TIERING:
            return 'INTELLIGENT_TIERING';
        default:
            return 'INTELLIGENT_TIERING';
    }
};
exports.getS3BucketStorageClassFromStorageDriveTier = getS3BucketStorageClassFromStorageDriveTier;
