"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getConfigSetParameterActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const qpqAwsLambdaRuntimeConfigUtils_1 = require("../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils");
const setParameter_1 = require("../../../logic/parametersManager/setParameter");
const getProcessConfigSetParameter = (qpqConfig) => {
    return ({ parameterName, parameterValue }) => __awaiter(void 0, void 0, void 0, function* () {
        const awsParameterKey = (0, qpqAwsLambdaRuntimeConfigUtils_1.resolveParameterKey)(parameterName, qpqConfig);
        yield (0, setParameter_1.setParameter)(awsParameterKey, quidproquo_core_1.qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig), parameterValue);
        return (0, quidproquo_core_1.actionResult)(void 0);
    });
};
const getConfigSetParameterActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.ConfigActionType.SetParameter]: getProcessConfigSetParameter(qpqConfig),
    });
});
exports.getConfigSetParameterActionProcessor = getConfigSetParameterActionProcessor;
