"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventAutoRespondActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
const isAuthValid_1 = require("../../utils/isAuthValid");
const getProcessAutoRespond = (qpqConfig) => {
    return ({ qpqEventRecord, matchResult }) => __awaiter(void 0, void 0, void 0, function* () {
        var _a;
        // Just auto respond for options requests
        if (qpqEventRecord.method === 'OPTIONS') {
            return (0, quidproquo_core_1.actionResult)({
                status: 200,
                isBase64Encoded: false,
                body: '',
                headers: quidproquo_webserver_1.qpqWebServerUtils.getCorsHeaders(qpqConfig, matchResult.config || {}, qpqEventRecord.headers),
            });
        }
        // TODO: We can pull out the jwt from the session if thats a better way?
        // Think about that when you dont have covid.
        const authValid = yield (0, isAuthValid_1.isAuthValid)(qpqConfig, quidproquo_webserver_1.qpqWebServerUtils.getHeaderValue('Authorization', qpqEventRecord.headers), quidproquo_webserver_1.qpqWebServerUtils.getHeaderValue('x-api-key', qpqEventRecord.headers), (_a = matchResult.config) === null || _a === void 0 ? void 0 : _a.routeAuthSettings);
        if (!authValid) {
            return (0, quidproquo_core_1.actionResult)({
                status: 401,
                isBase64Encoded: false,
                body: JSON.stringify({
                    message: 'You are unauthorized to access this resource',
                }),
                headers: quidproquo_webserver_1.qpqWebServerUtils.getCorsHeaders(qpqConfig, matchResult.config || {}, qpqEventRecord.headers),
            });
        }
        return (0, quidproquo_core_1.actionResult)(null);
    });
};
const getEventAutoRespondActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.AutoRespond]: getProcessAutoRespond(qpqConfig),
    });
});
exports.getEventAutoRespondActionProcessor = getEventAutoRespondActionProcessor;
