"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventGetRecordsActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
const awsToQoqEventTypeMap = {
    MESSAGE: quidproquo_webserver_1.WebSocketEventType.Message,
    CONNECT: quidproquo_webserver_1.WebSocketEventType.Connect,
    DISCONNECT: quidproquo_webserver_1.WebSocketEventType.Disconnect,
};
const getProcessGetRecords = (qpqConfig) => {
    return ({ eventParams: [websocketEvent, context] }) => __awaiter(void 0, void 0, void 0, function* () {
        const internalEventRecord = {
            eventType: awsToQoqEventTypeMap[websocketEvent.requestContext.eventType],
            messageId: websocketEvent.requestContext.messageId,
            connectionId: websocketEvent.requestContext.connectionId,
            requestTimeEpoch: websocketEvent.requestContext.requestTimeEpoch,
            sourceIp: websocketEvent.requestContext.identity.sourceIp,
            userAgent: websocketEvent.requestContext.identity.userAgent,
            requestTime: new Date(websocketEvent.requestContext.requestTimeEpoch).toISOString(),
            body: websocketEvent.body,
        };
        return (0, quidproquo_core_1.actionResult)([internalEventRecord]);
    });
};
const getEventGetRecordsActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
    });
});
exports.getEventGetRecordsActionProcessor = getEventGetRecordsActionProcessor;
