"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventAutoRespondActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const getProcessAutoRespond = (qpqConfig) => {
    return ({ qpqEventRecord, matchResult }) => __awaiter(void 0, void 0, void 0, function* () {
        // exit if we don't know what deploy type this is, probably another stack
        const earlyExit = qpqEventRecord.deployEventType === quidproquo_core_1.DeployEventType.Unknown || qpqEventRecord.deployEventStatusType === quidproquo_core_1.DeployEventStatusType.Unknown;
        // This is strange, but null means don't early exit.
        return (0, quidproquo_core_1.actionResult)(!earlyExit ? null : void 0);
    });
};
const getEventAutoRespondActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.AutoRespond]: getProcessAutoRespond(qpqConfig),
    });
});
exports.getEventAutoRespondActionProcessor = getEventAutoRespondActionProcessor;
