"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventGetRecordsActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
const types_1 = require("./types");
const getProcessGetRecords = (qpqConfig) => {
    return ({ eventParams: [s3Event, context] }) => __awaiter(void 0, void 0, void 0, function* () {
        const records = s3Event.Records.map((r) => {
            const internalEventRecord = {
                driveName: types_1.GLOBAL_STORAGE_DRIVE_NAME,
                // TODO: This only needs to be a single filepath now!
                filePaths: [decodeURIComponent(r.s3.object.key)],
                eventType: r.eventName.startsWith('ObjectCreated') ? quidproquo_webserver_1.StorageDriveEventType.Create : quidproquo_webserver_1.StorageDriveEventType.Delete,
            };
            return internalEventRecord;
        });
        return (0, quidproquo_core_1.actionResult)(records);
    });
};
const getEventGetRecordsActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
    });
});
exports.getEventGetRecordsActionProcessor = getEventGetRecordsActionProcessor;
