"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventGetRecordsActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const getProcessGetRecords = (qpqConfig) => {
    return ({ eventParams: [sqsEvent, context] }) => __awaiter(void 0, void 0, void 0, function* () {
        const records = sqsEvent.Records.map((record) => {
            const parsedInternalEventRecord = JSON.parse(record.body);
            // TODO: Remove the session from this object
            //       note: we still need to access the session in the story execution for depth and auth etc.
            const internalEventRecord = {
                message: {
                    type: parsedInternalEventRecord.type || 'AWS_ALARM',
                    payload: parsedInternalEventRecord.payload || {},
                },
                id: record.messageId,
            };
            return internalEventRecord;
        });
        return (0, quidproquo_core_1.actionResult)(records);
    });
};
const getEventGetRecordsActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
    });
});
exports.getEventGetRecordsActionProcessor = getEventGetRecordsActionProcessor;
