"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventTransformResponseResultActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const getProcessTransformResponseResult = (qpqConfig) => {
    // We might need to JSON.stringify the body.
    return ({ eventParams, qpqEventRecordResponses }) => __awaiter(void 0, void 0, void 0, function* () {
        const [sqsEvent] = eventParams;
        const batchItemFailures = qpqEventRecordResponses
            .filter((record) => !record.success)
            .map((record, index) => {
            const batchItemFailure = {
                itemIdentifier: sqsEvent.Records[index].messageId,
            };
            return batchItemFailure;
        });
        // Transform back to api gateway
        return (0, quidproquo_core_1.actionResult)({
            batchItemFailures,
        });
    });
};
const getEventTransformResponseResultActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.TransformResponseResult]: getProcessTransformResponseResult(qpqConfig),
    });
});
exports.getEventTransformResponseResultActionProcessor = getEventTransformResponseResultActionProcessor;
