"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventBusSendMessagesActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_core_2 = require("quidproquo-core");
const publishMessage_1 = require("../../../logic/sns/publishMessage");
const awsNamingUtils_1 = require("../../../awsNamingUtils");
const getProcessEventBusSendMessage = (qpqConfig) => {
    return ({ eventBusName, eventBusMessages, context, }, session) => __awaiter(void 0, void 0, void 0, function* () {
        var _a, _b, _c, _d, _e;
        const region = quidproquo_core_1.qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig);
        const eventBusConfig = quidproquo_core_1.qpqCoreUtils.getEventBusConfigByName(eventBusName, qpqConfig);
        if (!eventBusConfig) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `Event bus ${eventBusName} not found`);
        }
        const topicArn = (0, awsNamingUtils_1.getEventBusSnsTopicArn)(((_a = eventBusConfig.owner) === null || _a === void 0 ? void 0 : _a.resourceNameOverride) || eventBusName, qpqConfig, ((_b = eventBusConfig.owner) === null || _b === void 0 ? void 0 : _b.module) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig), ((_c = eventBusConfig.owner) === null || _c === void 0 ? void 0 : _c.environment) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig), ((_d = eventBusConfig.owner) === null || _d === void 0 ? void 0 : _d.application) || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig), ((_e = eventBusConfig.owner) === null || _e === void 0 ? void 0 : _e.feature) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig));
        yield (0, publishMessage_1.publishMessage)(topicArn, region, eventBusMessages.map((message) => {
            const eventBusMessageWithSession = Object.assign(Object.assign({}, message), { storySession: Object.assign(Object.assign({}, session), { context }) });
            return JSON.stringify(eventBusMessageWithSession);
        }));
        return (0, quidproquo_core_2.actionResult)(void 0);
    });
};
const getEventBusSendMessagesActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_2.EventBusActionType.SendMessages]: getProcessEventBusSendMessage(qpqConfig),
    });
});
exports.getEventBusSendMessagesActionProcessor = getEventBusSendMessagesActionProcessor;
