"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFileGenerateTemporarySecureUrlActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_core_2 = require("quidproquo-core");
const generatePresignedUrl_1 = require("../../../logic/s3/generatePresignedUrl");
const utils_1 = require("./utils");
const getProcessFileGenerateTemporarySecureUrl = (qpqConfig) => {
    return ({ drive, filepath, expirationMs }) => __awaiter(void 0, void 0, void 0, function* () {
        try {
            const s3BucketName = (0, utils_1.resolveStorageDriveBucketName)(drive, qpqConfig);
            const url = yield (0, generatePresignedUrl_1.generatePresignedUrl)(s3BucketName, filepath, quidproquo_core_1.qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig), expirationMs);
            return (0, quidproquo_core_2.actionResult)(url);
        }
        catch (error) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.GenericError, 'Unable to generate temporary secure URL', error);
        }
    });
};
const getFileGenerateTemporarySecureUrlActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_2.FileActionType.GenerateTemporarySecureUrl]: getProcessFileGenerateTemporarySecureUrl(qpqConfig),
    });
});
exports.getFileGenerateTemporarySecureUrlActionProcessor = getFileGenerateTemporarySecureUrlActionProcessor;
