"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getKeyValueStoreGetAllActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const awsNamingUtils_1 = require("../../../awsNamingUtils");
const quidproquo_core_2 = require("quidproquo-core");
const dynamo_1 = require("../../../logic/dynamo");
const getProcessKeyValueStoreGetAll = (qpqConfig) => {
    return ({ keyValueStoreName }) => __awaiter(void 0, void 0, void 0, function* () {
        const dynamoTableName = (0, awsNamingUtils_1.getKvsDynamoTableNameFromConfig)(keyValueStoreName, qpqConfig, 'kvs');
        const region = quidproquo_core_1.qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig);
        const result = yield (0, dynamo_1.getAllItems)(dynamoTableName, region);
        return (0, quidproquo_core_2.actionResult)(result);
    });
};
const getKeyValueStoreGetAllActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_2.KeyValueStoreActionType.GetAll]: getProcessKeyValueStoreGetAll(qpqConfig),
    });
});
exports.getKeyValueStoreGetAllActionProcessor = getKeyValueStoreGetAllActionProcessor;
