"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getQueueSendMessagesActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const qpqAwsLambdaRuntimeConfigUtils_1 = require("../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils");
const quidproquo_core_2 = require("quidproquo-core");
const sendMessages_1 = require("../../../logic/sqs/sendMessages");
const getProcessQueueSendMessage = (qpqConfig) => {
    return ({ queueName, queueMessages, context }, session) => __awaiter(void 0, void 0, void 0, function* () {
        // While we have some uuids
        const sqsQueueName = (0, qpqAwsLambdaRuntimeConfigUtils_1.resolveResourceName)(queueName, qpqConfig);
        yield (0, sendMessages_1.sendMessages)(sqsQueueName, quidproquo_core_1.qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig), queueMessages.map((message) => {
            // Add the session info to the message
            const queueMessageWithSession = Object.assign(Object.assign({}, message), { storySession: Object.assign(Object.assign({}, session), { context }) });
            return JSON.stringify(queueMessageWithSession);
        }));
        return (0, quidproquo_core_2.actionResult)(void 0);
    });
};
const getQueueSendMessagesActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_2.QueueActionType.SendMessages]: getProcessQueueSendMessage(qpqConfig),
    });
});
exports.getQueueSendMessagesActionProcessor = getQueueSendMessagesActionProcessor;
