"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUserDirectoryConfirmEmailVerificationActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const verifyUserEmail_1 = require("../../../logic/cognito/verifyUserEmail");
const getProcessConfirmEmailVerification = (qpqConfig) => {
    return ({ code, accessToken }) => __awaiter(void 0, void 0, void 0, function* () {
        const region = quidproquo_core_1.qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig);
        yield (0, verifyUserEmail_1.verifyUserEmail)(region, accessToken, code);
        return (0, quidproquo_core_1.actionResult)(void 0);
    });
};
const getUserDirectoryConfirmEmailVerificationActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.UserDirectoryActionType.ConfirmEmailVerification]: getProcessConfirmEmailVerification(qpqConfig),
    });
});
exports.getUserDirectoryConfirmEmailVerificationActionProcessor = getUserDirectoryConfirmEmailVerificationActionProcessor;
