"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getApiGatewayEventHandler_redirect = void 0;
const apiGatewayEventHandler_redirect = (event, context) => __awaiter(void 0, void 0, void 0, function* () {
    console.log('event: ', JSON.stringify(event, null, 2));
    console.log('process.env: ', JSON.stringify(process.env, null, 2));
    const redirectConfig = JSON.parse(process.env.redirectConfig);
    // For direct urls ~ Go straight to the url
    let redirectUrl = redirectConfig.redirectUrl;
    // Otherwise it must be a domain redirect
    if (!redirectConfig.redirectUrl.startsWith('http')) {
        const environment = JSON.parse(process.env.environment);
        const featureEnvironment = JSON.parse(process.env.featureEnvironment || '""');
        let baseDomain = redirectConfig.redirectUrl;
        if (redirectConfig.addEnvironment && environment !== 'production') {
            baseDomain = `${environment}.${baseDomain}`;
        }
        if (redirectConfig.addFeatureEnvironment && featureEnvironment) {
            baseDomain = `${featureEnvironment}.${baseDomain}`;
        }
        redirectUrl = `https://${baseDomain}${event.path}`;
    }
    // Add query parameters if they exist
    const queryParams = event.queryStringParameters;
    if (queryParams) {
        const queryString = Object.entries(queryParams)
            .filter(([, value]) => value !== undefined) // Filter out undefined values
            .map(([key, value]) => `${encodeURIComponent(key)}=${encodeURIComponent(value)}`)
            .join('&');
        redirectUrl += `?${queryString}`;
    }
    return {
        statusCode: 301,
        body: '',
        headers: {
            Location: redirectUrl,
        },
    };
});
const getApiGatewayEventHandler_redirect = () => apiGatewayEventHandler_redirect;
exports.getApiGatewayEventHandler_redirect = getApiGatewayEventHandler_redirect;
