"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sendMessageToWebSocketConnection = void 0;
const client_apigatewaymanagementapi_1 = require("@aws-sdk/client-apigatewaymanagementapi");
const createAwsClient_1 = require("../createAwsClient");
const sendMessageToWebSocketConnection = (apiId, connectionId, region, payload) => __awaiter(void 0, void 0, void 0, function* () {
    // Create a new ApiGatewayManagementApiClient
    const apiGatewayManagementApiClient = (0, createAwsClient_1.createAwsClient)(client_apigatewaymanagementapi_1.ApiGatewayManagementApiClient, {
        apiVersion: "2018-11-29",
        endpoint: `https://${apiId}.execute-api.${region}.amazonaws.com/prod`,
        region
    });
    // Create a new PostToConnectionCommand with the connection ID and payload
    const command = new client_apigatewaymanagementapi_1.PostToConnectionCommand({
        ConnectionId: connectionId,
        Data: JSON.stringify(payload) // Convert payload to string if necessary
    });
    yield apiGatewayManagementApiClient.send(command);
});
exports.sendMessageToWebSocketConnection = sendMessageToWebSocketConnection;
