"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getParameter = void 0;
const client_ssm_1 = require("@aws-sdk/client-ssm");
const memoFuncAsync_1 = require("../cache/memoFuncAsync");
const createAwsClient_1 = require("../createAwsClient");
exports.getParameter = (0, memoFuncAsync_1.memoFuncAsync)((parameterName, region) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const ssmClient = (0, createAwsClient_1.createAwsClient)(client_ssm_1.SSMClient, { region });
    const response = yield ssmClient.send(new client_ssm_1.GetParameterCommand({
        Name: parameterName,
    }));
    return ((_a = response.Parameter) === null || _a === void 0 ? void 0 : _a.Value) || '';
}), 60);
