"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generatePresignedUrl = void 0;
const client_s3_1 = require("@aws-sdk/client-s3");
const s3_request_presigner_1 = require("@aws-sdk/s3-request-presigner");
const createAwsClient_1 = require("../createAwsClient");
const generatePresignedUrl = (bucketName, objectKey, region, expirationMs) => __awaiter(void 0, void 0, void 0, function* () {
    const s3Client = (0, createAwsClient_1.createAwsClient)(client_s3_1.S3Client, { region });
    // Define the command for getting an object, which will be presigned
    const getObjectCommand = new client_s3_1.GetObjectCommand({
        Bucket: bucketName,
        Key: objectKey,
    });
    try {
        const url = yield (0, s3_request_presigner_1.getSignedUrl)(s3Client, getObjectCommand, { expiresIn: expirationMs / 1000 });
        return url;
    }
    catch (error) {
        console.error('Error generating presigned URL', error);
        throw error;
    }
});
exports.generatePresignedUrl = generatePresignedUrl;
