"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveParameterKey = exports.resolveSecretKey = exports.resolveResourceName = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const awsNamingUtils_1 = require("../awsNamingUtils");
const resolveResourceName = (resourceName, qpqConfig) => {
    return (0, awsNamingUtils_1.getConfigRuntimeResourceNameFromConfig)(resourceName, qpqConfig);
};
exports.resolveResourceName = resolveResourceName;
const resolveSecretKey = (secretName, qpqConfig) => {
    return (0, awsNamingUtils_1.getConfigRuntimeResourceNameFromConfig)(secretName, qpqConfig);
};
exports.resolveSecretKey = resolveSecretKey;
const resolveParameterKey = (parameterName, qpqConfig) => {
    var _a, _b;
    const secretConfig = quidproquo_core_1.qpqCoreUtils.getParameterConfig(parameterName, qpqConfig);
    return (0, awsNamingUtils_1.getConfigRuntimeResourceNameFromConfigWithServiceOverride)(((_a = secretConfig.owner) === null || _a === void 0 ? void 0 : _a.resourceNameOverride) || parameterName, qpqConfig, (_b = secretConfig.owner) === null || _b === void 0 ? void 0 : _b.module);
};
exports.resolveParameterKey = resolveParameterKey;
