import { ConfigActionType, actionResult, qpqCoreUtils, actionResultErrorFromCaughtError, actionResultError, ConfigGetParameterErrorTypeEnum, } from 'quidproquo-core';
import { resolveParameterKey } from '../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils';
import { getParameter } from '../../../logic/parametersManager/getParameter';
const getProcessConfigGetParameter = (qpqConfig) => {
    return async ({ parameterName }) => {
        const awsParameterKey = resolveParameterKey(parameterName, qpqConfig);
        try {
            const parameterValue = await getParameter(awsParameterKey, qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig));
            return actionResult(parameterValue);
        }
        catch (error) {
            return actionResultErrorFromCaughtError(error, {
                ThrottlingException: () => actionResultError(ConfigGetParameterErrorTypeEnum.Throttling, 'Throttling: Rate exceeded'),
            });
        }
    };
};
export const getConfigGetParameterActionProcessor = async (qpqConfig) => ({
    [ConfigActionType.GetParameter]: getProcessConfigGetParameter(qpqConfig),
});
