import { ConfigActionType, actionResult, qpqCoreUtils, actionResultErrorFromCaughtError, actionResultError, ConfigGetParametersErrorTypeEnum, } from 'quidproquo-core';
import { resolveParameterKey } from '../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils';
import { getParameters } from '../../../logic/parametersManager/getParameters';
const getProcessConfigGetParameters = (qpqConfig) => {
    return async ({ parameterNames }) => {
        const awsParameterKeys = parameterNames.map((pn) => resolveParameterKey(pn, qpqConfig));
        try {
            const parameterValues = await getParameters(awsParameterKeys, qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig));
            return actionResult(parameterValues);
        }
        catch (error) {
            return actionResultErrorFromCaughtError(error, {
                ThrottlingException: () => actionResultError(ConfigGetParametersErrorTypeEnum.Throttling, 'Throttling: Rate exceeded'),
            });
        }
    };
};
export const getConfigGetParametersActionProcessor = async (qpqConfig) => ({
    [ConfigActionType.GetParameters]: getProcessConfigGetParameters(qpqConfig),
});
