import { EventActionType, actionResult, } from 'quidproquo-core';
import { qpqWebServerUtils } from 'quidproquo-webserver';
const getProcessGetRecords = (qpqConfig) => {
    return async ({ eventParams: [cloudFrontRequestEvent, context] }) => {
        const records = cloudFrontRequestEvent.Records.map((record) => {
            const cfRecordRequest = record.cf.request;
            const headers = Object.keys(cfRecordRequest.headers).reduce((acc, header) => ({ ...acc, [header]: cfRecordRequest.headers[header][0].value }), {});
            const internalRecord = {
                domain: qpqWebServerUtils.getBaseDomainName(qpqConfig),
                body: cfRecordRequest.body,
                correlation: context.awsRequestId,
                method: cfRecordRequest.method,
                path: cfRecordRequest.uri,
                sourceIp: cfRecordRequest.clientIp,
                headers: headers,
                // TODO: query string support
                query: {},
            };
            return internalRecord;
        });
        return actionResult(records);
    };
};
export const getEventGetRecordsActionProcessor = async (qpqConfig) => ({
    [EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
});
