import { EventActionType, actionResult, } from 'quidproquo-core';
const getProcessTransformResponseResult = (qpqConfig) => {
    // We might need to JSON.stringify the body.
    return async ({ eventParams, qpqEventRecordResponses }) => {
        const [customMessageTriggerEvent] = eventParams;
        const [emailSendEventResponse] = qpqEventRecordResponses;
        if (emailSendEventResponse.success) {
            const updatedEvent = {
                ...customMessageTriggerEvent,
                response: {
                    ...customMessageTriggerEvent.response,
                    emailMessage: emailSendEventResponse.result.body,
                    emailSubject: emailSendEventResponse.result.subject,
                },
            };
            return actionResult(updatedEvent);
        }
        // Just let cognito handle the event
        return actionResult(customMessageTriggerEvent);
    };
};
export const getEventTransformResponseResultActionProcessor = async (qpqConfig) => ({
    [EventActionType.TransformResponseResult]: getProcessTransformResponseResult(qpqConfig),
});
