import { EventActionType, actionResult, } from 'quidproquo-core';
import { getQpqAttributesFromCognitoStringMap } from '../../../../../logic/cognito/cognitoAttributeMap';
import { getChallengeSessionFromCognitoTriggerEventSession } from '../utils';
const getProcessGetRecords = (qpqConfig) => {
    return async ({ eventParams: [event, context] }) => {
        const internalEventRecord = {
            userName: event.userName,
            session: getChallengeSessionFromCognitoTriggerEventSession(event.request.session),
            userAttributes: getQpqAttributesFromCognitoStringMap(event.request.userAttributes),
        };
        return actionResult([internalEventRecord]);
    };
};
export const getEventGetRecordsActionProcessor = async (qpqConfig) => ({
    [EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
});
