import { ErrorTypeEnum, EventActionType, actionResultError, qpqCoreUtils, } from 'quidproquo-core';
import { actionResult } from 'quidproquo-core';
// TODO: Don't use Globals like this
const GLOBAL_USER_DIRECTORY_NAME = process.env.userDirectoryName;
const getProcessMatchStory = (qpqConfig) => {
    const userDirectoryConfig = qpqCoreUtils.getUserDirectories(qpqConfig).find((ud) => ud.name === GLOBAL_USER_DIRECTORY_NAME);
    return async ({ qpqEventRecord }) => {
        if (!userDirectoryConfig?.customAuthRuntime?.verifyAuthChallenge) {
            return actionResultError(ErrorTypeEnum.NotFound, `Missing customAuthRuntime.verifyAuthChallenge in [${GLOBAL_USER_DIRECTORY_NAME}]`);
        }
        return actionResult({
            runtime: userDirectoryConfig.customAuthRuntime.verifyAuthChallenge,
        });
    };
};
export const getEventMatchStoryActionProcessor = async (qpqConfig) => ({
    [EventActionType.MatchStory]: getProcessMatchStory(qpqConfig),
});
