import { EventActionType, actionResult, } from 'quidproquo-core';
const getResponseFromErrorResult = (error) => {
    return {
        answerCorrect: false,
    };
};
const getProcessTransformResponseResult = (qpqConfig) => {
    // We might need to JSON.stringify the body.
    return async ({ eventParams, qpqEventRecordResponses }) => {
        const [customMessageTriggerEvent] = eventParams;
        const [qpqEventRecordResponse] = qpqEventRecordResponses;
        // If we have an error, we need to transform it to a response, otherwise we can just use the record as is
        let successRecord = qpqEventRecordResponse.success ? qpqEventRecordResponse.result : getResponseFromErrorResult(qpqEventRecordResponse.error);
        const eventOutput = {
            ...customMessageTriggerEvent,
            response: {
                ...customMessageTriggerEvent.response,
                answerCorrect: successRecord.answerCorrect,
            },
        };
        return actionResult(eventOutput);
    };
};
export const getEventTransformResponseResultActionProcessor = async (qpqConfig) => ({
    [EventActionType.TransformResponseResult]: getProcessTransformResponseResult(qpqConfig),
});
