import { EventActionType, actionResult, DeployEventType, DeployEventStatusType, } from 'quidproquo-core';
const getProcessAutoRespond = (qpqConfig) => {
    return async ({ qpqEventRecord, matchResult }) => {
        // exit if we don't know what deploy type this is, probably another stack
        const earlyExit = qpqEventRecord.deployEventType === DeployEventType.Unknown || qpqEventRecord.deployEventStatusType === DeployEventStatusType.Unknown;
        // This is strange, but null means don't early exit.
        return actionResult(!earlyExit ? null : void 0);
    };
};
export const getEventAutoRespondActionProcessor = async (qpqConfig) => ({
    [EventActionType.AutoRespond]: getProcessAutoRespond(qpqConfig),
});
