import { EventBridgeEvent, Context } from 'aws-lambda';
import { DeployEvent, DeployEventResponse, MatchStoryResult } from 'quidproquo-core';
interface CloudFormationEventDetail {
    'stack-id': string;
    'status-details': {
        status: string;
        'status-reason': string;
    };
}
export type EventInput = [EventBridgeEvent<'CloudFormation Stack Status Change', CloudFormationEventDetail>, Context];
export type EventOutput = void;
export type InternalEventRecord = DeployEvent;
export type InternalEventOutput = DeployEventResponse;
export type MatchResult = MatchStoryResult<any, any>;
export {};
