import { EventActionType, actionResult, } from 'quidproquo-core';
const getProcessGetRecords = (qpqConfig) => {
    return async ({ eventParams: [sqsEvent, context] }) => {
        const records = sqsEvent.Records.map((record) => {
            const parsedInternalEventRecord = JSON.parse(record.body);
            // TODO: Remove the session from this object
            //       note: we still need to access the session in the story execution for depth and auth etc.
            const internalEventRecord = {
                message: {
                    type: parsedInternalEventRecord.type || 'AWS_ALARM',
                    payload: parsedInternalEventRecord.payload || {},
                },
                id: record.messageId,
            };
            return internalEventRecord;
        });
        return actionResult(records);
    };
};
export const getEventGetRecordsActionProcessor = async (qpqConfig) => ({
    [EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
});
