import { EventActionType, actionResult, } from 'quidproquo-core';
const getProcessTransformResponseResult = (qpqConfig) => {
    // We might need to JSON.stringify the body.
    return async ({ eventParams, qpqEventRecordResponses }) => {
        const [sqsEvent] = eventParams;
        const batchItemFailures = qpqEventRecordResponses
            .filter((record) => !record.success)
            .map((record, index) => {
            const batchItemFailure = {
                itemIdentifier: sqsEvent.Records[index].messageId,
            };
            return batchItemFailure;
        });
        // Transform back to api gateway
        return actionResult({
            batchItemFailures,
        });
    };
};
export const getEventTransformResponseResultActionProcessor = async (qpqConfig) => ({
    [EventActionType.TransformResponseResult]: getProcessTransformResponseResult(qpqConfig),
});
