import { ErrorTypeEnum, actionResultError, qpqCoreUtils } from 'quidproquo-core';
import { actionResult, FileActionType } from 'quidproquo-core';
import { generatePresignedUrl } from '../../../logic/s3/generatePresignedUrl';
import { resolveStorageDriveBucketName } from './utils';
const getProcessFileGenerateTemporarySecureUrl = (qpqConfig) => {
    return async ({ drive, filepath, expirationMs }) => {
        try {
            const s3BucketName = resolveStorageDriveBucketName(drive, qpqConfig);
            const url = await generatePresignedUrl(s3BucketName, filepath, qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig), expirationMs);
            return actionResult(url);
        }
        catch (error) {
            return actionResultError(ErrorTypeEnum.GenericError, 'Unable to generate temporary secure URL', error);
        }
    };
};
export const getFileGenerateTemporarySecureUrlActionProcessor = async (qpqConfig) => ({
    [FileActionType.GenerateTemporarySecureUrl]: getProcessFileGenerateTemporarySecureUrl(qpqConfig),
});
