import { actionResult, FileActionType, qpqCoreUtils, } from 'quidproquo-core';
import { resolveStorageDriveBucketName } from './utils';
import { writeTextFile } from '../../../logic/s3/s3Utils';
import { getS3BucketStorageClassFromStorageDriveTier } from '../../../awsLambdaUtils';
const getProcessFileWriteTextContents = (qpqConfig) => {
    return async ({ drive, filepath, data, storageDriveAdvancedWriteOptions }) => {
        const s3BucketName = resolveStorageDriveBucketName(drive, qpqConfig);
        await writeTextFile(s3BucketName, filepath, data, qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig), getS3BucketStorageClassFromStorageDriveTier(storageDriveAdvancedWriteOptions?.storageDriveTier));
        return actionResult(void 0);
    };
};
export const getFileWriteTextContentsActionProcessor = async (qpqConfig) => ({
    [FileActionType.WriteTextContents]: getProcessFileWriteTextContents(qpqConfig),
});
