import { qpqCoreUtils } from 'quidproquo-core';
import { resolveResourceName } from '../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils';
import { actionResult, QueueActionType } from 'quidproquo-core';
import { sendMessages } from '../../../logic/sqs/sendMessages';
const getProcessQueueSendMessage = (qpqConfig) => {
    return async ({ queueName, queueMessages, context }, session) => {
        // While we have some uuids
        const sqsQueueName = resolveResourceName(queueName, qpqConfig);
        await sendMessages(sqsQueueName, qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig), queueMessages.map((message) => {
            // Add the session info to the message
            const queueMessageWithSession = {
                ...message,
                storySession: {
                    ...session,
                    context,
                },
            };
            return JSON.stringify(queueMessageWithSession);
        }));
        return actionResult(void 0);
    };
};
export const getQueueSendMessagesActionProcessor = async (qpqConfig) => ({
    [QueueActionType.SendMessages]: getProcessQueueSendMessage(qpqConfig),
});
