import { actionResult, qpqCoreUtils, UserDirectoryActionType, } from 'quidproquo-core';
import { getCFExportNameUserPoolIdFromConfig, getCFExportNameUserPoolClientIdFromConfig } from '../../../awsNamingUtils';
import { forgotPassword } from '../../../logic/cognito/forgotPassword';
import { getExportedValue } from '../../../logic/cloudformation/getExportedValue';
const getProcessForgotPassword = (qpqConfig) => {
    return async ({ username, userDirectoryName }) => {
        const region = qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig);
        const userPoolId = await getExportedValue(getCFExportNameUserPoolIdFromConfig(userDirectoryName, qpqConfig), region);
        const userPoolClientId = await getExportedValue(getCFExportNameUserPoolClientIdFromConfig(userDirectoryName, qpqConfig), region);
        const authResponse = await forgotPassword(userPoolId, userPoolClientId, qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig), username);
        return actionResult(authResponse);
    };
};
export const getUserDirectoryForgotPasswordActionProcessor = async (qpqConfig) => ({
    [UserDirectoryActionType.ForgotPassword]: getProcessForgotPassword(qpqConfig),
});
