import { actionResult, qpqCoreUtils, UserDirectoryActionType, } from 'quidproquo-core';
import { requestEmailVerificationCode } from '../../../logic/cognito/requestEmailVerificationCode';
const getProcessRequestEmailVerification = (qpqConfig) => {
    return async ({ userDirectoryName, accessToken }) => {
        const region = qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig);
        await requestEmailVerificationCode(region, accessToken);
        return actionResult(void 0);
    };
};
export const getUserDirectoryRequestEmailVerificationActionProcessor = async (qpqConfig) => ({
    [UserDirectoryActionType.RequestEmailVerification]: getProcessRequestEmailVerification(qpqConfig),
});
