import { APIGatewayClient, GetApiKeysCommand, } from '@aws-sdk/client-api-gateway';
import { createAwsClient } from '../createAwsClient';
export const getApiKeys = async (region, ...keyNames) => {
    const apiGatewayClient = createAwsClient(APIGatewayClient, { region });
    const input = {
        includeValues: true,
        limit: 500,
    };
    const res = await apiGatewayClient.send(new GetApiKeysCommand(input));
    return (res.items
        ?.filter((i) => keyNames.indexOf(i.name) >= 0)
        .map((i) => ({ name: i.name, value: i.value, description: i.description })) || []);
};
