import { CognitoIdentityProviderClient, ConfirmForgotPasswordCommand, } from '@aws-sdk/client-cognito-identity-provider';
import { calculateSecretHash } from './utils/calculateSecretHash';
import { getUserPoolClientSecret } from './getUserPoolClientSecret';
import { authenticateUser } from './authenticateUser';
import { createAwsClient } from '../createAwsClient';
export const confirmForgotPassword = async (userPoolId, clientId, region, code, username, password) => {
    const cognitoClient = createAwsClient(CognitoIdentityProviderClient, { region });
    const clientSecret = await getUserPoolClientSecret(userPoolId, clientId, region);
    const secretHash = calculateSecretHash(username, clientId, clientSecret);
    const params = {
        ClientId: clientId,
        ConfirmationCode: code,
        SecretHash: secretHash,
        Password: password,
        Username: username,
    };
    await cognitoClient.send(new ConfirmForgotPasswordCommand(params));
    // Authenticate the user
    const authResponse = await authenticateUser(userPoolId, clientId, region, false, username, password);
    return authResponse;
};
