import { CognitoIdentityProviderClient, AdminGetUserCommand, } from '@aws-sdk/client-cognito-identity-provider';
import { getQpqAttributesFromCognitoUserAttributes } from './cognitoAttributeMap';
import { createAwsClient } from '../createAwsClient';
export const getUserAttributes = async (userPoolId, region, username) => {
    const cognitoClient = createAwsClient(CognitoIdentityProviderClient, { region });
    const params = {
        UserPoolId: userPoolId,
        Username: username,
    };
    const response = await cognitoClient.send(new AdminGetUserCommand(params));
    const validAttributes = (response.UserAttributes || []).filter((attr) => attr.Name && attr.Value);
    const attributes = getQpqAttributesFromCognitoUserAttributes(validAttributes);
    return attributes;
};
