import { CognitoIdentityProviderClient, ListUsersCommand, } from '@aws-sdk/client-cognito-identity-provider';
import { getQpqAttributesFromCognitoUserAttributes } from './cognitoAttributeMap';
import { createAwsClient } from '../createAwsClient';
export const getUserAttributesBySub = async (userPoolId, region, sub) => {
    const cognitoClient = createAwsClient(CognitoIdentityProviderClient, { region });
    const response = await cognitoClient.send(new ListUsersCommand({
        UserPoolId: userPoolId,
        Filter: `sub = "${sub}"`,
    }));
    const [user] = response?.Users || [];
    if (!user) {
        throw new Error('User not found');
    }
    const validAttributes = (user.Attributes || []).filter((attr) => attr.Name && attr.Value);
    return getQpqAttributesFromCognitoUserAttributes(validAttributes);
};
