import { CognitoIdentityProviderClient, AdminUpdateUserAttributesCommand, } from '@aws-sdk/client-cognito-identity-provider';
import { getCognitoUserAttributesFromQpqUserAttributes } from './cognitoAttributeMap';
import { createAwsClient } from '../createAwsClient';
export const setUserAttributes = async (userPoolId, region, username, userAttributes) => {
    const cognitoClient = createAwsClient(CognitoIdentityProviderClient, { region });
    const { userId, ...writeableUserAttributes } = userAttributes;
    const params = {
        UserPoolId: userPoolId,
        Username: username,
        UserAttributes: getCognitoUserAttributesFromQpqUserAttributes(writeableUserAttributes),
    };
    await cognitoClient.send(new AdminUpdateUserAttributesCommand(params));
};
