import { DynamoDBClient, DeleteItemCommand, } from '@aws-sdk/client-dynamodb';
import { buildAttributeValue } from './qpqDynamoOrm';
import { createAwsClient } from '../createAwsClient';
export async function deleteItem(tableName, region, key, keyName, sortKey, sortKeyName) {
    const dynamoDBClient = createAwsClient(DynamoDBClient, { region });
    const deleteItemParams = {
        TableName: tableName,
        Key: {
            [keyName]: buildAttributeValue(key),
        },
    };
    if (sortKey && sortKeyName) {
        deleteItemParams.Key[sortKeyName] = buildAttributeValue(sortKey);
    }
    await dynamoDBClient.send(new DeleteItemCommand(deleteItemParams));
}
