import { DynamoDBClient, ReturnValue, UpdateItemCommand } from '@aws-sdk/client-dynamodb';
import { buildAttributeValue, buildDynamoUpdateExpression, buildUpdateExpressionAttributeNames, buildUpdateExpressionAttributeValues, } from './qpqDynamoOrm';
import { createAwsClient } from '../createAwsClient';
import { convertDynamoMapToObject } from './convertObjectToDynamoMap';
export async function updateItem(tableName, region, update, keyName, key, sortkeyName, sortKey) {
    const dynamoDBClient = createAwsClient(DynamoDBClient, { region });
    const params = {
        TableName: tableName,
        Key: {
            [keyName]: buildAttributeValue(key),
        },
        UpdateExpression: buildDynamoUpdateExpression(update),
        ExpressionAttributeValues: buildUpdateExpressionAttributeValues(update),
        ExpressionAttributeNames: buildUpdateExpressionAttributeNames(update),
        ReturnValues: ReturnValue.ALL_NEW,
    };
    if (sortkeyName && sortKey !== undefined) {
        params.Key[sortkeyName] = buildAttributeValue(sortKey);
    }
    const result = await dynamoDBClient.send(new UpdateItemCommand(params));
    return convertDynamoMapToObject(result.Attributes);
}
